// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from collision_log_msgs:msg/NamedCollision.idl
// generated code does not contain a copyright notice

#ifndef COLLISION_LOG_MSGS__MSG__DETAIL__NAMED_COLLISION__FUNCTIONS_H_
#define COLLISION_LOG_MSGS__MSG__DETAIL__NAMED_COLLISION__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "collision_log_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "collision_log_msgs/msg/detail/named_collision__struct.h"

/// Initialize msg/NamedCollision message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * collision_log_msgs__msg__NamedCollision
 * )) before or use
 * collision_log_msgs__msg__NamedCollision__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_collision_log_msgs
bool
collision_log_msgs__msg__NamedCollision__init(collision_log_msgs__msg__NamedCollision * msg);

/// Finalize msg/NamedCollision message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_collision_log_msgs
void
collision_log_msgs__msg__NamedCollision__fini(collision_log_msgs__msg__NamedCollision * msg);

/// Create msg/NamedCollision message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * collision_log_msgs__msg__NamedCollision__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_collision_log_msgs
collision_log_msgs__msg__NamedCollision *
collision_log_msgs__msg__NamedCollision__create();

/// Destroy msg/NamedCollision message.
/**
 * It calls
 * collision_log_msgs__msg__NamedCollision__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_collision_log_msgs
void
collision_log_msgs__msg__NamedCollision__destroy(collision_log_msgs__msg__NamedCollision * msg);

/// Check for msg/NamedCollision message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_collision_log_msgs
bool
collision_log_msgs__msg__NamedCollision__are_equal(const collision_log_msgs__msg__NamedCollision * lhs, const collision_log_msgs__msg__NamedCollision * rhs);

/// Copy a msg/NamedCollision message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_collision_log_msgs
bool
collision_log_msgs__msg__NamedCollision__copy(
  const collision_log_msgs__msg__NamedCollision * input,
  collision_log_msgs__msg__NamedCollision * output);

/// Initialize array of msg/NamedCollision messages.
/**
 * It allocates the memory for the number of elements and calls
 * collision_log_msgs__msg__NamedCollision__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_collision_log_msgs
bool
collision_log_msgs__msg__NamedCollision__Sequence__init(collision_log_msgs__msg__NamedCollision__Sequence * array, size_t size);

/// Finalize array of msg/NamedCollision messages.
/**
 * It calls
 * collision_log_msgs__msg__NamedCollision__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_collision_log_msgs
void
collision_log_msgs__msg__NamedCollision__Sequence__fini(collision_log_msgs__msg__NamedCollision__Sequence * array);

/// Create array of msg/NamedCollision messages.
/**
 * It allocates the memory for the array and calls
 * collision_log_msgs__msg__NamedCollision__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_collision_log_msgs
collision_log_msgs__msg__NamedCollision__Sequence *
collision_log_msgs__msg__NamedCollision__Sequence__create(size_t size);

/// Destroy array of msg/NamedCollision messages.
/**
 * It calls
 * collision_log_msgs__msg__NamedCollision__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_collision_log_msgs
void
collision_log_msgs__msg__NamedCollision__Sequence__destroy(collision_log_msgs__msg__NamedCollision__Sequence * array);

/// Check for msg/NamedCollision message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_collision_log_msgs
bool
collision_log_msgs__msg__NamedCollision__Sequence__are_equal(const collision_log_msgs__msg__NamedCollision__Sequence * lhs, const collision_log_msgs__msg__NamedCollision__Sequence * rhs);

/// Copy an array of msg/NamedCollision messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_collision_log_msgs
bool
collision_log_msgs__msg__NamedCollision__Sequence__copy(
  const collision_log_msgs__msg__NamedCollision__Sequence * input,
  collision_log_msgs__msg__NamedCollision__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // COLLISION_LOG_MSGS__MSG__DETAIL__NAMED_COLLISION__FUNCTIONS_H_
