// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from collision_log_msgs:msg/NamedCollision.idl
// generated code does not contain a copyright notice

#ifndef COLLISION_LOG_MSGS__MSG__DETAIL__NAMED_COLLISION__TRAITS_HPP_
#define COLLISION_LOG_MSGS__MSG__DETAIL__NAMED_COLLISION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "collision_log_msgs/msg/detail/named_collision__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace collision_log_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const NamedCollision & msg,
  std::ostream & out)
{
  out << "{";
  // member: entity0
  {
    out << "entity0: ";
    rosidl_generator_traits::value_to_yaml(msg.entity0, out);
    out << ", ";
  }

  // member: entity1
  {
    out << "entity1: ";
    rosidl_generator_traits::value_to_yaml(msg.entity1, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const NamedCollision & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: entity0
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "entity0: ";
    rosidl_generator_traits::value_to_yaml(msg.entity0, out);
    out << "\n";
  }

  // member: entity1
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "entity1: ";
    rosidl_generator_traits::value_to_yaml(msg.entity1, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const NamedCollision & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace collision_log_msgs

namespace rosidl_generator_traits
{

[[deprecated("use collision_log_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const collision_log_msgs::msg::NamedCollision & msg,
  std::ostream & out, size_t indentation = 0)
{
  collision_log_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use collision_log_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const collision_log_msgs::msg::NamedCollision & msg)
{
  return collision_log_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<collision_log_msgs::msg::NamedCollision>()
{
  return "collision_log_msgs::msg::NamedCollision";
}

template<>
inline const char * name<collision_log_msgs::msg::NamedCollision>()
{
  return "collision_log_msgs/msg/NamedCollision";
}

template<>
struct has_fixed_size<collision_log_msgs::msg::NamedCollision>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<collision_log_msgs::msg::NamedCollision>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<collision_log_msgs::msg::NamedCollision>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // COLLISION_LOG_MSGS__MSG__DETAIL__NAMED_COLLISION__TRAITS_HPP_
