// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from collision_log_msgs:msg/NamedCollisions.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "collision_log_msgs/msg/detail/named_collisions__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace collision_log_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void NamedCollisions_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) collision_log_msgs::msg::NamedCollisions(_init);
}

void NamedCollisions_fini_function(void * message_memory)
{
  auto typed_message = static_cast<collision_log_msgs::msg::NamedCollisions *>(message_memory);
  typed_message->~NamedCollisions();
}

size_t size_function__NamedCollisions__collisions(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<collision_log_msgs::msg::NamedCollision> *>(untyped_member);
  return member->size();
}

const void * get_const_function__NamedCollisions__collisions(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<collision_log_msgs::msg::NamedCollision> *>(untyped_member);
  return &member[index];
}

void * get_function__NamedCollisions__collisions(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<collision_log_msgs::msg::NamedCollision> *>(untyped_member);
  return &member[index];
}

void fetch_function__NamedCollisions__collisions(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const collision_log_msgs::msg::NamedCollision *>(
    get_const_function__NamedCollisions__collisions(untyped_member, index));
  auto & value = *reinterpret_cast<collision_log_msgs::msg::NamedCollision *>(untyped_value);
  value = item;
}

void assign_function__NamedCollisions__collisions(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<collision_log_msgs::msg::NamedCollision *>(
    get_function__NamedCollisions__collisions(untyped_member, index));
  const auto & value = *reinterpret_cast<const collision_log_msgs::msg::NamedCollision *>(untyped_value);
  item = value;
}

void resize_function__NamedCollisions__collisions(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<collision_log_msgs::msg::NamedCollision> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember NamedCollisions_message_member_array[2] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(collision_log_msgs::msg::NamedCollisions, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "collisions",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<collision_log_msgs::msg::NamedCollision>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(collision_log_msgs::msg::NamedCollisions, collisions),  // bytes offset in struct
    nullptr,  // default value
    size_function__NamedCollisions__collisions,  // size() function pointer
    get_const_function__NamedCollisions__collisions,  // get_const(index) function pointer
    get_function__NamedCollisions__collisions,  // get(index) function pointer
    fetch_function__NamedCollisions__collisions,  // fetch(index, &value) function pointer
    assign_function__NamedCollisions__collisions,  // assign(index, value) function pointer
    resize_function__NamedCollisions__collisions  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers NamedCollisions_message_members = {
  "collision_log_msgs::msg",  // message namespace
  "NamedCollisions",  // message name
  2,  // number of fields
  sizeof(collision_log_msgs::msg::NamedCollisions),
  NamedCollisions_message_member_array,  // message members
  NamedCollisions_init_function,  // function to initialize message memory (memory has to be allocated)
  NamedCollisions_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t NamedCollisions_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &NamedCollisions_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace collision_log_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<collision_log_msgs::msg::NamedCollisions>()
{
  return &::collision_log_msgs::msg::rosidl_typesupport_introspection_cpp::NamedCollisions_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, collision_log_msgs, msg, NamedCollisions)() {
  return &::collision_log_msgs::msg::rosidl_typesupport_introspection_cpp::NamedCollisions_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
