// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from collision_log_msgs:msg/NamedCollision.idl
// generated code does not contain a copyright notice
#include "collision_log_msgs/msg/detail/named_collision__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `entity0`
// Member `entity1`
#include "rosidl_runtime_c/string_functions.h"

bool
collision_log_msgs__msg__NamedCollision__init(collision_log_msgs__msg__NamedCollision * msg)
{
  if (!msg) {
    return false;
  }
  // entity0
  if (!rosidl_runtime_c__String__init(&msg->entity0)) {
    collision_log_msgs__msg__NamedCollision__fini(msg);
    return false;
  }
  // entity1
  if (!rosidl_runtime_c__String__init(&msg->entity1)) {
    collision_log_msgs__msg__NamedCollision__fini(msg);
    return false;
  }
  return true;
}

void
collision_log_msgs__msg__NamedCollision__fini(collision_log_msgs__msg__NamedCollision * msg)
{
  if (!msg) {
    return;
  }
  // entity0
  rosidl_runtime_c__String__fini(&msg->entity0);
  // entity1
  rosidl_runtime_c__String__fini(&msg->entity1);
}

bool
collision_log_msgs__msg__NamedCollision__are_equal(const collision_log_msgs__msg__NamedCollision * lhs, const collision_log_msgs__msg__NamedCollision * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // entity0
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->entity0), &(rhs->entity0)))
  {
    return false;
  }
  // entity1
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->entity1), &(rhs->entity1)))
  {
    return false;
  }
  return true;
}

bool
collision_log_msgs__msg__NamedCollision__copy(
  const collision_log_msgs__msg__NamedCollision * input,
  collision_log_msgs__msg__NamedCollision * output)
{
  if (!input || !output) {
    return false;
  }
  // entity0
  if (!rosidl_runtime_c__String__copy(
      &(input->entity0), &(output->entity0)))
  {
    return false;
  }
  // entity1
  if (!rosidl_runtime_c__String__copy(
      &(input->entity1), &(output->entity1)))
  {
    return false;
  }
  return true;
}

collision_log_msgs__msg__NamedCollision *
collision_log_msgs__msg__NamedCollision__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  collision_log_msgs__msg__NamedCollision * msg = (collision_log_msgs__msg__NamedCollision *)allocator.allocate(sizeof(collision_log_msgs__msg__NamedCollision), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(collision_log_msgs__msg__NamedCollision));
  bool success = collision_log_msgs__msg__NamedCollision__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
collision_log_msgs__msg__NamedCollision__destroy(collision_log_msgs__msg__NamedCollision * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    collision_log_msgs__msg__NamedCollision__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
collision_log_msgs__msg__NamedCollision__Sequence__init(collision_log_msgs__msg__NamedCollision__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  collision_log_msgs__msg__NamedCollision * data = NULL;

  if (size) {
    data = (collision_log_msgs__msg__NamedCollision *)allocator.zero_allocate(size, sizeof(collision_log_msgs__msg__NamedCollision), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = collision_log_msgs__msg__NamedCollision__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        collision_log_msgs__msg__NamedCollision__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
collision_log_msgs__msg__NamedCollision__Sequence__fini(collision_log_msgs__msg__NamedCollision__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      collision_log_msgs__msg__NamedCollision__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

collision_log_msgs__msg__NamedCollision__Sequence *
collision_log_msgs__msg__NamedCollision__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  collision_log_msgs__msg__NamedCollision__Sequence * array = (collision_log_msgs__msg__NamedCollision__Sequence *)allocator.allocate(sizeof(collision_log_msgs__msg__NamedCollision__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = collision_log_msgs__msg__NamedCollision__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
collision_log_msgs__msg__NamedCollision__Sequence__destroy(collision_log_msgs__msg__NamedCollision__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    collision_log_msgs__msg__NamedCollision__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
collision_log_msgs__msg__NamedCollision__Sequence__are_equal(const collision_log_msgs__msg__NamedCollision__Sequence * lhs, const collision_log_msgs__msg__NamedCollision__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!collision_log_msgs__msg__NamedCollision__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
collision_log_msgs__msg__NamedCollision__Sequence__copy(
  const collision_log_msgs__msg__NamedCollision__Sequence * input,
  collision_log_msgs__msg__NamedCollision__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(collision_log_msgs__msg__NamedCollision);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    collision_log_msgs__msg__NamedCollision * data =
      (collision_log_msgs__msg__NamedCollision *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!collision_log_msgs__msg__NamedCollision__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          collision_log_msgs__msg__NamedCollision__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!collision_log_msgs__msg__NamedCollision__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
