// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from collision_log_msgs:msg/NamedCollision.idl
// generated code does not contain a copyright notice

#ifndef COLLISION_LOG_MSGS__MSG__DETAIL__NAMED_COLLISION__STRUCT_H_
#define COLLISION_LOG_MSGS__MSG__DETAIL__NAMED_COLLISION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'entity0'
// Member 'entity1'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/NamedCollision in the package collision_log_msgs.
/**
  * Message to indicate a collision between two entities.
  * The second entity name can be blank if a sensor detects a collision but doesn't have a name for the object
 */
typedef struct collision_log_msgs__msg__NamedCollision
{
  rosidl_runtime_c__String entity0;
  rosidl_runtime_c__String entity1;
} collision_log_msgs__msg__NamedCollision;

// Struct for a sequence of collision_log_msgs__msg__NamedCollision.
typedef struct collision_log_msgs__msg__NamedCollision__Sequence
{
  collision_log_msgs__msg__NamedCollision * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} collision_log_msgs__msg__NamedCollision__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // COLLISION_LOG_MSGS__MSG__DETAIL__NAMED_COLLISION__STRUCT_H_
