// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from collision_log_msgs:msg/NamedCollisions.idl
// generated code does not contain a copyright notice

#ifndef COLLISION_LOG_MSGS__MSG__DETAIL__NAMED_COLLISIONS__TRAITS_HPP_
#define COLLISION_LOG_MSGS__MSG__DETAIL__NAMED_COLLISIONS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "collision_log_msgs/msg/detail/named_collisions__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'collisions'
#include "collision_log_msgs/msg/detail/named_collision__traits.hpp"

namespace collision_log_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const NamedCollisions & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: collisions
  {
    if (msg.collisions.size() == 0) {
      out << "collisions: []";
    } else {
      out << "collisions: [";
      size_t pending_items = msg.collisions.size();
      for (auto item : msg.collisions) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const NamedCollisions & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: collisions
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.collisions.size() == 0) {
      out << "collisions: []\n";
    } else {
      out << "collisions:\n";
      for (auto item : msg.collisions) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const NamedCollisions & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace collision_log_msgs

namespace rosidl_generator_traits
{

[[deprecated("use collision_log_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const collision_log_msgs::msg::NamedCollisions & msg,
  std::ostream & out, size_t indentation = 0)
{
  collision_log_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use collision_log_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const collision_log_msgs::msg::NamedCollisions & msg)
{
  return collision_log_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<collision_log_msgs::msg::NamedCollisions>()
{
  return "collision_log_msgs::msg::NamedCollisions";
}

template<>
inline const char * name<collision_log_msgs::msg::NamedCollisions>()
{
  return "collision_log_msgs/msg/NamedCollisions";
}

template<>
struct has_fixed_size<collision_log_msgs::msg::NamedCollisions>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<collision_log_msgs::msg::NamedCollisions>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<collision_log_msgs::msg::NamedCollisions>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // COLLISION_LOG_MSGS__MSG__DETAIL__NAMED_COLLISIONS__TRAITS_HPP_
